using UnityEngine;
using System.Collections.Generic;

public class BinaryMG : QuizBase 
{
	// Game parameters
	private List<bool> binaryValues;
	private int targetValue, currentValue;
	
	// Display current
	bool displayCurrent;
	int displayTimer;
	
	// Use this for initialization
	void Start () 
	{
		
	}
	
	protected override void initMinigame()
	{
		int maxTargetValue = 0;
		
		// Apply challenge rating.
		switch(challengeRating)
		{
		case 1:
			maxTargetValue = 15;
			displayCurrent = true;
			break;
		case 2:
			maxTargetValue = 31;
			displayCurrent = true;
			break;
		case 3:
			maxTargetValue = 63;
			displayCurrent = false;
			break;
		case 4:
			maxTargetValue = 127;
			displayCurrent = false;
			break;
		case 5:
			maxTargetValue = 255;
			displayCurrent = false;
			break;
		default:
			break;
		}
		
		// Establish current and target values.
		targetValue = Random.Range(1, maxTargetValue);
		currentValue = 0;
		
		// Set up the binary table.
		binaryValues = new List<bool>();
		for (int i = 0; i < challengeRating + 3; i++)
		{
			binaryValues.Add(false);	
		}
	}
	
	// Update is called once per frame
	void Update () 
	{
		if (guiActive)
		{
			currentValue = 0;
			for (int i = 0; i < binaryValues.Count; i++)
			{
				if (binaryValues[i])
				{
					currentValue += (int)Mathf.Pow(2, i);			
				}
			}
			
			/*if (currentValue == targetValue)
			{
				success = true;
				guiActive = false;
			}*/
			
			if (displayTimer > 0)
				displayTimer--;
		}
		else
		{

		}
	}
	
	void OnGUI()
	{
		if (guiActive)
		{
			// Apply GUISkin
			GUI.skin = skin;
				
			// Background window.
			GUI.Box(new Rect(Screen.width*0.15f, Screen.height*0.2f, Screen.width*0.7f, Screen.height*0.6f), "");
			
			// Help button
			if (GUI.Button(new Rect(Screen.width*0.18f, Screen.height*0.68f, Screen.width*0.2f, Screen.height*0.05f), "?"))
			{
				help = !help;
			}
			
			if (help)
			{
				// Help screen.
				GUI.Label(new Rect(Screen.width*0.2f, Screen.height*0.2f, Screen.width*0.6f, Screen.height*0.6f),
					"Binary Conversion: \n\n" +
					"Convert the given number to Binary: \n" +
					"Binary is a base-2 numberal system; each digit represents a power of 2 " +
					"instead of a power of 10.");
			}
			else
			{
				// Puzzle screen.
				
				// Left number out: target value.
				GUI.Box(new Rect(Screen.width*0.25f, Screen.height*0.25f, Screen.width*0.2f, Screen.height*0.15f), "", "InnerBox");
				GUI.Label(new Rect(Screen.width*0.26f, Screen.height*0.26f, 
					Screen.width*0.18f, Screen.height*0.13f), targetValue.ToString());
				
				// Right number out: current value.
				GUI.Box(new Rect(Screen.width*0.55f, Screen.height*0.25f, Screen.width*0.2f, Screen.height*0.15f), "", "InnerBox");
				if (displayCurrent || displayTimer > 0)
				{
					GUI.Label(new Rect(Screen.width*0.56f, Screen.height*0.26f, 
						Screen.width*0.18f, Screen.height*0.13f), currentValue.ToString());
				}
				
				// Binary switches.
				GUILayout.BeginArea(new Rect(Screen.width*0.2f, Screen.height*0.5f, Screen.width*0.6f, Screen.height*0.1f));
				GUILayout.BeginHorizontal();
				for (int i = binaryValues.Count-1; i >= 0; i--)
				{
					GUILayout.FlexibleSpace();
					binaryValues[i] = GUILayout.Toggle(binaryValues[i], "");
					GUILayout.FlexibleSpace();
				}
				GUILayout.EndHorizontal();
				GUILayout.EndArea();
				
				// Confirm button
				if (GUI.Button(new Rect(Screen.width*0.78f, Screen.height*0.68f, Screen.width*0.05f, Screen.width*0.05f), "OK"))
				{
					if (currentValue == targetValue)
					{
						success = true;
						guiActive = false;
						
						//Debug.Log("If I make it, I become it: "+success); 
						
					 	GameObject player = GameObject.Find("ZigguratPlayer"); 
						//Debug.Log("I am: "+player.transform.position); 
						
						// tLefty
						if (player.transform.position.x < 0 && player.transform.position.z > 0)
						{
							GameObject visible = GameObject.Find("tLefty"); 
							visible.GetComponent<wallVisibilitytLefty>().visibilityOn = true;
						}
						
						// tRighty
						if (player.transform.position.x > 0 && player.transform.position.z > 0)
						{
							GameObject visible = GameObject.Find("tRighty"); 
							visible.GetComponent<wallVisibilitytRighty>().visibilityOn = true;
						}
						
						// bLefty
						if (player.transform.position.x < 0 && player.transform.position.z < 0)
						{
							GameObject visible = GameObject.Find("bLefty"); 
							visible.GetComponent<wallVisibilitybLefty>().visibilityOn = true;
						}
						
						
						if (player.transform.position.x > 0 && player.transform.position.z < 0)
						{
							GameObject visible = GameObject.Find("bRighty"); 
							visible.GetComponent<wallVisibilitybRighty>().visibilityOn = true;
						}
					}
					
					if (!displayCurrent)
						displayTimer = 100;
				}
				// Close button
				if (GUI.Button(new Rect(Screen.width*0.70f, Screen.height*0.68f, Screen.width*0.05f, Screen.width*0.05f), "X"))
				{
					guiActive = false;
				}
			}
		}
	}
}
